import * as Discord from 'discord.js';
import "dotenv/config";
import { init } from './init';
const { Guilds, GuildMessages, MessageContent, GuildMessageReactions, GuildVoiceStates, GuildMembers } = Discord.GatewayIntentBits;
const { Message, Channel, Reaction } = Discord.Partials;
const client = new Discord.Client({ 
    intents: [Guilds, GuildMessages, MessageContent, GuildMessageReactions, GuildVoiceStates, GuildMembers],
    partials: [Message, Channel, Reaction],
});

const bot = init();
client.once("ready", async () => {
    client.guilds.cache.forEach((guild) => {
        bot.setting(guild.id);
    });
    console.log("명령어 등록 완료");
    console.log(client.user?.tag + " 봇 실행");

    // try {
    //     const guild = await client.guilds.fetch("1321652896017940562");
    //     const meb = await guild.members.fetch();
    //     console.log("불러옴");
    //     meb.forEach(async (m) => {
    //         if(m.nickname?.includes("˚🐾") && m.roles.cache.has("1339897926998036480")) {
    //             const regex = /‧₊˚🐾(.*)/;
    //             const match = m.nickname.match(regex);
    //             if(match) { 
    //                 const newNickname = `‧₊˚🎧 ${match[1]}༉‧₊˚.`;
    //                 if (newNickname.length <= 32) {
    //                     await m.setNickname(newNickname);
    //                     console.log(m.nickname+"님 변경");
    //                 }else {
    //                     const newNickname = `‧₊˚🎧 ${match[1].charAt(0)}༉‧₊˚.`;
    //                     await m.setNickname(newNickname);
    //                     console.log(m.nickname+"님 변경");
    //                 }
    //             }    
    //         }
    //     });
    // }catch(e) {
    //     console.log(e);
    // }
});

client.on("interactionCreate", (inte) => {
    bot.run(inte);
});

client.login(process.env.TOKEN);